package com.maroontress.coverture;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;

/**
   Covertureεư饹Ǥ
*/
public final class Coverture {

    /** ХåեΥ */
    private static final int BUFFER_SIZE = 4096;

    /**
       ư饹Υ󥹥󥹤ޤ
    */
    private Coverture() {
    }

    /**
       ˡɽƽλޤ
    */
    private static void usage() {
        System.err.print(""
+ "Usage: java com.maroontress.coverture.Coverture [options] [file...]\n"
+ "Options are:\n"
+ "  --input-file=FILE       Read the list of files from FILE.\n"
+ "  --version               Show version and exit.\n"
+ "");
        System.exit(1);
    }

    /**
       СϤƽλޤ
    */
    private static void version() {
        InputStream in = Coverture.class.getResourceAsStream("version");
        byte[] data = new byte[BUFFER_SIZE];
        int size;
        try {
            while ((size = in.read(data)) > 0) {
                System.out.write(data, 0, size);
            }
            in.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
        System.exit(1);
    }

    /**
       ե뤫gcnoե̾ΥꥹȤϤgcnoե
       ޤ

       @param inputFile Ϥե̾
       @throws IOException
       @throws CorruptedFileException
       @throws UnexpectedTagException
    */
    private static void processFileList(final String inputFile,
					final PrintWriter out)
	throws IOException, CorruptedFileException, UnexpectedTagException {
	try {
	    BufferedReader rd = new BufferedReader(new FileReader(inputFile));
	    String name;
	    while ((name = rd.readLine()) != null) {
		Note note = Note.parse(name);
		note.printXML(out);
	    }
	} catch (FileNotFoundException e) {
	    System.err.println("File not found: " + e.getMessage());
	    System.exit(1);
	}
    }

    /**
       Coverture¹Ԥޤ

       @param av ޥɥ饤󥪥ץ
    */
    public static void main(final String[] av) {
        ArgumentParser ap = new ArgumentParser(av);
        Argument arg;
	String inputFile = null;

        while ((arg = ap.getArgument()) != null && arg.isOption()) {
            String name = arg.getName();
            String value = arg.getValue();
            if (name.equals("--version")) {
                version();
            } else if (name.equals("--input-file") && value != null) {
                inputFile = value;
            } else {
                usage();
            }
        }
	if (arg == null && inputFile == null) {
	    usage();
	}
	try {
	    PrintWriter out = new PrintWriter(System.out);
	    out.println("<gcno>");
	    for (; arg != null; arg = ap.getArgument()) {
		Note note = Note.parse(arg.getName());
		note.printXML(out);
	    }
	    if (inputFile != null) {
		processFileList(inputFile, out);
	    }
	    out.println("</gcno>");
	    out.close();
	} catch (Exception e) {
	    e.printStackTrace();
	    System.exit(1);
	}
	System.exit(0);
    }
}
